#include <vector>

void changeContent1(int* x) // pass by pointer
{
	*x = 345; // this also changes the value in the caller
}

void changeContent2(int& x) // pass by reference
{
	x = 456; // this also changes the value in the caller
}

int main(int argc, char *argv[])
{
	int u = 43;
	int *p = &u; // pointer to u
	*p = 98; // change what's in u
	int foo = *p + 1; // read what's in u

	int a[] = {234, 345, 234, 456, 234};
	// all but the first dimension have to be specified,
	// even if you spell out the items to initalize the array with
	int b[][3] = {{23,54,56},{78,23,23},{67,234,23}};
	int c[4][5];
	c[3][2] = b[2][1];
	
	*(a+3) = 43; // accesses a[3]; you could synonymously write a[3]
	*(*(b+2)+1) = 63; // accesses b[2][1]
	
	int *v = a; // an array's name is a pointer to its first element a[0]
	v++; // v now points to the element a[1]
	v[0] = 32; // access a[1], alternatively write *v
	int* v1 = &(a[0]); // a pointer to element number 0, the same as a itself
	
	int (*w)[5] = c; // w now is a pointer to the row number 0
	w++; // next row
	*(*(w+2)+3) = 42; // same as w[2][3]
	w[0][0] = 45;

	int& r = u; // "reference": r becomes another name for u
	// note that this "&" means something
	// completely different from int* p1 = &u
	//
	// int&  :  the type is "reference to int"
	// &u    :  fetch the address of u

	r++; // u changes, too

	changeContent1(&u); // pass by pointer
	changeContent2(u); // pass by reference (dangerous: looks like pass by value)

	std::vector<int> myVec; // like Java's vector
	myVec.push_back(34); // append at the end
	myVec.push_back(45);
	myVec.push_back(65);
	myVec[2] = 4*myVec[1]; // can be accessed like a standard array
	myVec.push_back(45);
	// Crashes:
	// myVec[9999] = 42; // will be caught in debug mode by an assertion
	// myVec.at(9999) = 42; // similar to access with square brackets, but violations of the array's limits will _always_ be caught by an exception

	return 0;
}